# encoding: UTF-8

class Vulnerability
  module Output

    # output the vulnerability
    def output
      puts ' |'
      puts ' | ' + red("* Title: #{title}")
      references.each do |r|
        puts ' | ' + red("* Reference: #{r}")
      end
      metasploit_modules.each do |m|
        puts ' | ' + red("* Metasploit module: #{Output.metasploit_module_url(m)}")
      end
    end

    # @return [ String ] The url to the metasploit module page
    def self.metasploit_module_url(module_path)
      # remove leading slash
      module_path = module_path.sub(/^\//, '')
      "http://www.metasploit.com/modules/#{module_path}"
    end

  end
end
